"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("underscore"));
var countryLookup = __importStar(require("country-code-lookup"));
var ck_lib_1 = require("@ckstack/ck-lib");
exports.default = {
    isNumber: function (val) { return _.isNumber(val) && !Number.isNaN(Number(val)); },
    isOptionalNumber: function (val) { return (val === undefined) || (_.isNumber(val) && !Number.isNaN(Number(val))); },
    isOptionalGteZeroNumber: function (val) { return (val === undefined) || (_.isNumber(val) && !Number.isNaN(Number(val)) && Number(val) >= 0); },
    isOptionalGtZeroNumber: function (val) { return (val === undefined) || (_.isNumber(val) && !Number.isNaN(Number(val)) && Number(val) > 0); },
    isGteZeroNumber: function (val) { return _.isNumber(val) && !Number.isNaN(Number(val)) && Number(val) >= 0; },
    isGtZeroNumber: function (val) { return _.isNumber(val) && !Number.isNaN(Number(val)) && Number(val) > 0; },
    isString: function (val) { return _.isString(val); },
    isOptionalString: function (val) { return (val === undefined) || _.isString(val); },
    isOptionalNotTrimEmptyString: function (val) { return (val === undefined) || (_.isString(val) && val.trim() !== ''); },
    isNotEmtpyString: function (val) { return _.isString(val) && val !== ''; },
    isNotTrimEmptyString: function (val) { return _.isString(val) && val.trim() !== ''; },
    isOptionalBooleanString: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        var str = val.toLowerCase();
        return (str === 'true' || str === 'false');
    },
    isBooleanString: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        var str = val.toLowerCase();
        return (str === 'true' || str === 'false');
    },
    isOptionalNumberString: function (val) {
        if (val === undefined) {
            return true;
        }
        return !(!_.isString(val) || val.trim() === '' || Number.isNaN(Number(val)));
    },
    isNumberString: function (val) {
        if (val === undefined) {
            return true;
        }
        return !(!_.isString(val) || val.trim() === '' || Number.isNaN(Number(val)));
    },
    isOptionalGtNumberString: function (val) {
        if (val === undefined) {
            return true;
        }
        return !(!_.isString(val) || val.trim() === '' || Number.isNaN(Number(val)) || Number(val) <= 0);
    },
    isOptionalGteNumberString: function (val) {
        if (val === undefined) {
            return true;
        }
        return !(!_.isString(val) || val.trim() === '' || Number.isNaN(Number(val)) || Number(val) < 0);
    },
    isBoolean: function (val) { return _.isBoolean(val); },
    isOptionalBoolean: function (val) { return (val === undefined) || _.isBoolean(val); },
    isObject: function (val) { return _.isObject(val); },
    isOptionalObject: function (val) { return (val === undefined) || _.isObject(val); },
    isOptionalNotEmptyObject: function (val) { return (val === undefined) || (_.isObject(val) && _.size(val) > 0); },
    isNotEmptyObject: function (val) { return _.isObject(val) && _.size(val) > 0; },
    isArray: function (val) { return _.isArray(val); },
    isOptionalArray: function (val) { return (val === undefined) || _.isArray(val); },
    isNotEmptyArray: function (val) { return _.isArray(val) && _.size(val) > 0; },
    isNotTrimEmptyStringNotEmptyArray: function (val) {
        if (!_.isArray(val) || _.size(val) <= 0) {
            return false;
        }
        for (var _i = 0, val_1 = val; _i < val_1.length; _i++) {
            var element = val_1[_i];
            if (!_.isString(element) || element.trim() === '') {
                return false;
            }
        }
        return true;
    },
    isOptionalNotTrimEmptyStringNotEmptyArray: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isArray(val) || _.size(val) <= 0) {
            return false;
        }
        for (var _i = 0, val_2 = val; _i < val_2.length; _i++) {
            var element = val_2[_i];
            if (!_.isString(element) || element.trim() === '') {
                return false;
            }
        }
        return true;
    },
    isOptionalNotEmptyObjectNotEmptyArray: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isArray(val) || _.size(val) <= 0) {
            return false;
        }
        for (var _i = 0, val_3 = val; _i < val_3.length; _i++) {
            var element = val_3[_i];
            if (!_.isObject(element) || _.size(element) <= 0) {
                return false;
            }
        }
        return true;
    },
    isOptionalNotTrimEmptyStringArray: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isArray(val)) {
            return false;
        }
        for (var _i = 0, val_4 = val; _i < val_4.length; _i++) {
            var element = val_4[_i];
            if (!_.isString(element) || element.trim() === '') {
                return false;
            }
        }
        return true;
    },
    isNotEmptyNumberArray: function (val) {
        if (!_.isArray(val)) {
            return false;
        }
        if (_.size(val) <= 0) {
            return false;
        }
        for (var _i = 0, val_5 = val; _i < val_5.length; _i++) {
            var element = val_5[_i];
            if (!_.isNumber(element)) {
                return false;
            }
        }
        return true;
    },
    isOptionalNumberArray: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isArray(val)) {
            return false;
        }
        for (var _i = 0, val_6 = val; _i < val_6.length; _i++) {
            var element = val_6[_i];
            if (!_.isNumber(element)) {
                return false;
            }
        }
        return true;
    },
    isStatus: function (val) {
        if (!_.isNumber(val) || val === ck_lib_1.CkValue.STATUS.PAUSE) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.STATUS, val);
    },
    isOptionalStatus: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isNumber(val) || val === ck_lib_1.CkValue.STATUS.PAUSE) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.STATUS, val);
    },
    isFullStatus: function (val) {
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.STATUS, val);
    },
    isOptionalFullStatus: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.STATUS, val);
    },
    isRole: function (val) {
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.ROLE, val);
    },
    isOptionalRole: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.ROLE, val);
    },
    isRoles: function (val) {
        if (val === undefined) {
            return false;
        }
        if (!_.isArray(val)) {
            return false;
        }
        if (val.length <= 0) {
            return false;
        }
        var keys = Object.keys(ck_lib_1.CkValue.ROLE);
        var roleType = [];
        for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
            var row = keys_1[_i];
            roleType.push(ck_lib_1.CkValue.ROLE[row]);
        }
        for (var _a = 0, val_7 = val; _a < val_7.length; _a++) {
            var row = val_7[_a];
            if (!roleType.includes(row)) {
                return false;
            }
        }
        return true;
    },
    isOptionalRoles: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isArray(val)) {
            return false;
        }
        if (val.length <= 0) {
            return false;
        }
        var keys = Object.keys(ck_lib_1.CkValue.ROLE);
        var roleType = [];
        for (var _i = 0, keys_2 = keys; _i < keys_2.length; _i++) {
            var row = keys_2[_i];
            roleType.push(ck_lib_1.CkValue.ROLE[row]);
        }
        for (var _a = 0, val_8 = val; _a < val_8.length; _a++) {
            var row = val_8[_a];
            if (!roleType.includes(row)) {
                return false;
            }
        }
        return true;
    },
    isMqttProtocol: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.MQTT_PROTOCOL, val);
    },
    isOptionalMqttProtocol: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.MQTT_PROTOCOL, val);
    },
    isTerminal: function (val) {
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.TERMINAL, val);
    },
    isOptionalTerminal: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.TERMINAL, val);
    },
    isSocialType: function (val) {
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.SOCIAL_TYPE, val);
    },
    isOptionalSocialType: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.SOCIAL_TYPE, val);
    },
    isGender: function (val) {
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.GENDER, val);
    },
    isOptionalGender: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.GENDER, val);
    },
    isConfigType: function (val) {
        if (_.isArray(val)) {
            if (val.length <= 0) {
                return false;
            }
            for (var _i = 0, val_9 = val; _i < val_9.length; _i++) {
                var row = val_9[_i];
                if (!ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.CONFIG_TYPE, row)) {
                    return false;
                }
            }
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.CONFIG_TYPE, val);
    },
    isOptionalConfigType: function (val) {
        if (val === undefined) {
            return true;
        }
        if (_.isArray(val)) {
            if (val.length <= 0) {
                return false;
            }
            for (var _i = 0, val_10 = val; _i < val_10.length; _i++) {
                var row = val_10[_i];
                if (!ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.CONFIG_TYPE, row)) {
                    return false;
                }
            }
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.CONFIG_TYPE, val);
    },
    isYYYYMM: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        if (val.length !== 6) {
            return false;
        }
        var dayRegExp = /^[1-2][0-9]\d{2}(0[1-9]|1[012])$/;
        return dayRegExp.test(val);
    },
    isOptionalYYYYMM: function (val) {
        if (val === undefined) {
            return true;
        }
        if (val.length !== 6) {
            return false;
        }
        var dayRegExp = /^[1-2][0-9]\d{2}(0[1-9]|1[012])$/;
        return dayRegExp.test(val);
    },
    isYYYYMMDD: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        if (val.length !== 8) {
            return false;
        }
        var dayRegExp = /^[1-2][0-9]\d{2}(0[1-9]|1[012])(0[1-9]|[12][0-9]|3[0-1])$/;
        return dayRegExp.test(val);
    },
    isOptionalYYYYMMDD: function (val) {
        if (val === undefined) {
            return true;
        }
        if (val.length !== 8) {
            return false;
        }
        var dayRegExp = /^[1-2][0-9]\d{2}(0[1-9]|1[012])(0[1-9]|[12][0-9]|3[0-1])$/;
        return dayRegExp.test(val);
    },
    isEmailAddress: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        var regExp = /^[0-9a-zA-Z]([-_.]?[0-9a-zA-Z])*@[0-9a-zA-Z]([-_.]?[0-9a-zA-Z])*.[a-zA-Z]{2,3}$/i;
        return (val.match(regExp) !== null);
    },
    isOptionalEmailAddress: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        var regExp = /^[0-9a-zA-Z]([-_.]?[0-9a-zA-Z])*@[0-9a-zA-Z]([-_.]?[0-9a-zA-Z])*.[a-zA-Z]{2,3}$/i;
        return (val.match(regExp) !== null);
    },
    isURL: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        var result = val.match(/(http(s)?:\/\/.)?(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)/g);
        return !(result === null);
    },
    isOptionalURL: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        var result = val.match(/(http(s)?:\/\/.)?(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)/g);
        return !(result === null);
    },
    isTimeZone: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        return _.contains(ck_lib_1.CkTimeZone.TIME_ZONES, val);
    },
    isOptionalTimeZone: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        return _.contains(ck_lib_1.CkTimeZone.TIME_ZONES, val);
    },
    isCountryCode: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        if (!countryLookup.byIso(val)) {
            return false;
        }
        return true;
    },
    isOptionalCountryCode: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        if (!countryLookup.byIso(val)) {
            return false;
        }
        return true;
    },
    isListOrder: function (val) {
        if (!_.isObject(val)) {
            return false;
        }
        if (!val.col) {
            return false;
        }
        if (!_.isString(val.col)) {
            return false;
        }
        if (!val.dir) {
            return false;
        }
        if (!ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.COL_DIR, val.dir)) {
            return false;
        }
        return true;
    },
    isOptionalListOrder: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isObject(val)) {
            return false;
        }
        if (!val.col) {
            return false;
        }
        if (!_.isString(val.col)) {
            return false;
        }
        if (!val.dir) {
            return false;
        }
        if (!ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.COL_DIR, val.dir)) {
            return false;
        }
        return true;
    },
    isMosquittoAclAuth: function (val) {
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.MOSQUITTO_ACL_AUTH, val);
    },
    isOptionalMosquittoAclAuth: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.MOSQUITTO_ACL_AUTH, val);
    },
    isLogLevel: function (val) {
        if (typeof val !== 'string') {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.LOG_LEVEL, val);
    },
    isOptionalLogLevel: function (val) {
        if (val === undefined) {
            return true;
        }
        if (typeof val !== 'string') {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.LOG_LEVEL, val);
    },
    isTemplateStruct: function (val) {
        if (val === undefined) {
            return false;
        }
        if (typeof val !== 'object') {
            return false;
        }
        if (Array.isArray(val)) {
            return false;
        }
        if (Object.keys(val).length <= 0) {
            return true;
        }
        var checkStruct = function (obj, depth) {
            var keys = Object.keys(obj);
            for (var _i = 0, keys_3 = keys; _i < keys_3.length; _i++) {
                var row = keys_3[_i];
                if (depth % 2 === 0) {
                    if (obj[row] === null) {
                        return false;
                    }
                    if (typeof obj[row] !== 'object') {
                        return false;
                    }
                    if (Array.isArray(obj[row])) {
                        return false;
                    }
                    if (row === 'type' || row === 'label' || row === 'mandatory' || row === 'name' || row === 'data') {
                        return false;
                    }
                    var submenuKeys = Object.keys(obj[row]);
                    if (!submenuKeys.includes('type')) {
                        return false;
                    }
                    if (!submenuKeys.includes('label')) {
                        return false;
                    }
                    if (!submenuKeys.includes('name')) {
                        return false;
                    }
                    if (!ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.TEMPLATE_COMPONENT, obj[row].type)) {
                        return false;
                    }
                    if (obj[row].name !== row) {
                        return false;
                    }
                    if (obj[row].type === ck_lib_1.CkValue.TEMPLATE_COMPONENT.ARRAY
                        || obj[row].type === ck_lib_1.CkValue.TEMPLATE_COMPONENT.OBJECT) {
                        if (!submenuKeys.includes('data')) {
                            return false;
                        }
                        if (typeof obj[row].data !== 'object') {
                            return false;
                        }
                        if (Array.isArray(obj[row].data)) {
                            return false;
                        }
                    }
                }
                if (typeof obj[row] === 'object' && !Array.isArray(obj[row])) {
                    var ret = checkStruct(obj[row], depth + 1);
                    if (!ret) {
                        return false;
                    }
                }
            }
            return true;
        };
        return checkStruct(val, 0);
    },
    isOptionalTemplateStruct: function (val) {
        if (val === undefined) {
            return true;
        }
        if (typeof val !== 'object') {
            return false;
        }
        if (Array.isArray(val)) {
            return false;
        }
        if (Object.keys(val).length <= 0) {
            return true;
        }
        var checkStruct = function (obj, depth) {
            var keys = Object.keys(obj);
            for (var _i = 0, keys_4 = keys; _i < keys_4.length; _i++) {
                var row = keys_4[_i];
                if (depth % 2 === 0) {
                    if (obj[row] === null) {
                        return false;
                    }
                    if (typeof obj[row] !== 'object') {
                        return false;
                    }
                    if (Array.isArray(obj[row])) {
                        return false;
                    }
                    if (row === 'type' || row === 'label' || row === 'mandatory' || row === 'name' || row === 'data') {
                        return false;
                    }
                    var submenuKeys = Object.keys(obj[row]);
                    if (!submenuKeys.includes('type')) {
                        return false;
                    }
                    if (!submenuKeys.includes('label')) {
                        return false;
                    }
                    if (!submenuKeys.includes('name')) {
                        return false;
                    }
                    if (!ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.TEMPLATE_COMPONENT, obj[row].type)) {
                        return false;
                    }
                    if (obj[row].name !== row) {
                        return false;
                    }
                    if (obj[row].type === ck_lib_1.CkValue.TEMPLATE_COMPONENT.ARRAY
                        || obj[row].type === ck_lib_1.CkValue.TEMPLATE_COMPONENT.OBJECT) {
                        if (!submenuKeys.includes('data')) {
                            return false;
                        }
                        if (typeof obj[row].data !== 'object') {
                            return false;
                        }
                        if (Array.isArray(obj[row].data)) {
                            return false;
                        }
                    }
                }
                if (typeof obj[row] === 'object' && !Array.isArray(obj[row])) {
                    var ret = checkStruct(obj[row], depth + 1);
                    if (!ret) {
                        return false;
                    }
                }
            }
            return true;
        };
        return checkStruct(val, 0);
    },
    isEmailAddressFrom: function (val) {
        if (val === undefined) {
            return false;
        }
        if (val.name && typeof val.name !== 'string') {
            return false;
        }
        if (!val.address || !val.address.trim()) {
            return false;
        }
        if (!ck_lib_1.CkUtils.isValidEmailAddress(val.address.trim())) {
            return false;
        }
        return true;
    },
    isOptionalEmailAddressFrom: function (val) {
        if (val === undefined) {
            return true;
        }
        if (val.name && typeof val.name !== 'string') {
            return false;
        }
        if (!val.address || !val.address.trim()) {
            return false;
        }
        if (!ck_lib_1.CkUtils.isValidEmailAddress(val.address.trim())) {
            return false;
        }
        return true;
    },
    isEmailAddressTo: function (val) {
        if (val === undefined) {
            return false;
        }
        if (Array.isArray(val)) {
            if (val.length <= 0) {
                return false;
            }
            for (var _i = 0, val_11 = val; _i < val_11.length; _i++) {
                var row = val_11[_i];
                if (row.name && typeof row.name !== 'string') {
                    return false;
                }
                if (!row.address || !row.address.trim()) {
                    return false;
                }
                if (!ck_lib_1.CkUtils.isValidEmailAddress(row.address.trim())) {
                    return false;
                }
            }
        }
        else {
            if (val.name && typeof val.name !== 'string') {
                return false;
            }
            if (!val.address || !val.address.trim()) {
                return false;
            }
            if (!ck_lib_1.CkUtils.isValidEmailAddress(val.address.trim())) {
                return false;
            }
        }
        return true;
    },
    isOptionalEmailAddressTo: function (val) {
        if (val === undefined) {
            return true;
        }
        if (Array.isArray(val)) {
            if (val.length <= 0) {
                return false;
            }
            for (var _i = 0, val_12 = val; _i < val_12.length; _i++) {
                var row = val_12[_i];
                if (row.name && typeof row.name !== 'string') {
                    return false;
                }
                if (!row.address || !row.address.trim()) {
                    return false;
                }
                if (!ck_lib_1.CkUtils.isValidEmailAddress(row.address.trim())) {
                    return false;
                }
            }
        }
        else {
            if (val.name && typeof val.name !== 'string') {
                return false;
            }
            if (!val.address || !val.address.trim()) {
                return false;
            }
            if (!ck_lib_1.CkUtils.isValidEmailAddress(val.address.trim())) {
                return false;
            }
        }
        return true;
    },
    isCidr: function (val) {
        if (val === undefined) {
            return false;
        }
        if (!_.isString(val)) {
            return false;
        }
        if (val.indexOf('/') < 0) {
            return false;
        }
        var regExp = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(\/(3[0-2]|2[0-9]|1[0-9]|[0-9]))?$/;
        return (val.match(regExp) !== null);
    },
    isOptionalCidr: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        if (val.indexOf('/') < 0) {
            return false;
        }
        var regExp = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(\/(3[0-2]|2[0-9]|1[0-9]|[0-9]))?$/;
        return (val.match(regExp) !== null);
    },
    isCidrWithAsterica: function (val) {
        if (val === undefined) {
            return false;
        }
        if (!_.isString(val)) {
            return false;
        }
        if (val === '*') {
            return true;
        }
        if (val.indexOf('/') < 0) {
            return false;
        }
        var regExp = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(\/(3[0-2]|2[0-9]|1[0-9]|[0-9]))?$/;
        return (val.match(regExp) !== null);
    },
    isOptionalCidrWithAsterica: function (val) {
        if (val === undefined) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        if (val === '*') {
            return true;
        }
        if (val.indexOf('/') < 0) {
            return false;
        }
        var regExp = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(\/(3[0-2]|2[0-9]|1[0-9]|[0-9]))?$/;
        return (val.match(regExp) !== null);
    },
};
